<?php
/**
 * @author Thomas Tanghus
 * @copyright 2013-2014 Thomas Tanghus (thomas@tanghus.net)
 *
 * This file is licensed under the Affero General Public License version 3 or
 * later.
 * See the COPYING-README file.
 */

namespace OCA\Media;

use OCP\AppFramework\App as MainApp,
	OCP\AppFramework\IAppContainer,
	OCA\Media\App,
	OCA\Media\Controller\PageController,
	OCA\Media\Controller\SettingsController;

/**
 * This class manages our app actions
 *
 * TODO: Merge with App
 */

class Dispatcher extends MainApp {

	/**
	 * @var string
	 */
	protected $appName;

	/**
	* @var \OCA\Media\App
	*/
	protected $app;

	/**
	* @var \OCP\IServerContainer
	*/
	protected $server;

	/**
	* @var \OCP\AppFramework\IAppContainer
	*/
	protected $container;

	public function __construct($params) {
		$this->appName = 'media';
		parent::__construct($this->appName, $params);
		$this->container = $this->getContainer();
		$this->server = $this->container->getServer();
		$this->app = new App($this->container->query('API')->getUserId());
		$this->registerServices();
	}

	public function registerServices() {
		$app = $this->app;
		$appName = $this->appName;

		$this->container->registerService('PageController', function(IAppContainer $container) use($app, $appName) {
			$request = $container->query('Request');
			return new PageController($appName, $request);
		});
		$this->container->registerService('SettingsController', function(IAppContainer $container) use($app, $appName) {
			$request = $container->query('Request');
			return new SettingsController($appName, $request, $app);
		});
	}

}
